<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_social_enhance".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeSocialEnhance".
 *
 * Columns in table "provider_practice_social_enhance" available as properties of the model,
 * followed by relations of table "provider_social_enhance" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $listing_type_id
 * @property string $app_type
 * @property integer $social_enhance_token_id
 * @property string $last_post_date
 * @property string $date_added
 * @property string $date_updated
 * @property integer $added_by_account_id
 * @property integer $updated_by_account_id
 * @property string $last_change_log
 *
 * @property ListingType $listingType
 * @property SocialEnhanceToken $socialEnhanceToken
 * @property AccountProvider $account
 * @property AccountPractice $account
 * @property Provider $provider
 * @property Practice $practice
 */
abstract class BaseProviderPracticeSocialEnhance extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_social_enhance';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeSocialEnhance|ProviderPracticeSocialEnhances', $n);
    }

    public static function representingColumn()
    {
        return 'social_enhance_token_id';
    }

    public function rules()
    {
        return array(
            array('account_id, social_enhance_token_id, listing_type_id, app_type', 'required'),
            array(
                'account_id, provider_id, practice_id, social_enhance_token_id, listing_type_id, added_by_account_id,
                    updated_by_account_id',
                'numerical',
                'integerOnly' => true
            ),
            array('date_updated, last_post_date, date_added', 'safe'),
            array(
                'provider_id, practice_id, last_post_date, date_added, date_updated',
                'default',
                'setOnEmpty' => true,
                'value' => null
            ),
            array(
                'id, account_id, provider_id, practice_id, listing_type_id, app_type, social_enhance_token_id,
                last_post_date, date_added, date_upated, added_by_account_id, updated_by_account_id',
                'safe',
                'on' => 'search'
            ),
        );
    }

    public function relations()
    {
        return array(
            'listingType' => array(self::BELONGS_TO, 'ListingType', 'listing_type_id'),
            'socialEnhanceToken' => array(self::BELONGS_TO, 'SocialEnhanceToken', 'social_enhance_token_id'),
            'account' => array(self::BELONGS_TO, 'AccountProvider', 'account_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'provider_id' => null,
            'practice_id' => null,
            'listing_type_id' => null,
            'app_type' => null,
            'social_enhance_token_id' => Yii::t('app', 'Social Enhance Token Id'),
            'last_post_date' => Yii::t('app', 'Last Post Date'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'added_by_account_id' => null,
            'updated_by_account_id' => null,
            'listingType' => null,
            'account' => null,
            'provider' => null,
            'practice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('listing_type_id', $this->listing_type_id);
        $criteria->compare('app_type', $this->app_type);
        $criteria->compare('social_enhance_token_id', $this->social_enhance_token_id, true);
        $criteria->compare('last_post_date', $this->last_post_date, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }
}
